/******************************************************************************
 CScrollPane.h

		Interface for the ScrollPane Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added DoScroll method
	]
		
 ******************************************************************************/
 
#define _H_CScrollPane

#include "CPane.h"						/* Interface for its superclass		*/

	// Forward declarations
	
class CPanorama;
class CScrollBar;
class CSizeBox;

class CScrollPane : public CPane {			/* CLASS DECLARATION				*/

public:
								/** Instance Variables **/
	CPanorama	*itsPanorama;			/* View which scrolls				*/
	CScrollBar	*itsHorizSBar;			/* Horizontal scroll bar			*/
	CScrollBar	*itsVertSBar;			/* Vertical scroll bar				*/
	CSizeBox	*itsSizeBox;			/* Grow box							*/
	long		hExtent;
	long		vExtent;
	short		hUnit;
	short		vUnit;
	short		hSpan;
	short		vSpan;
	short		hStep;
	short		vStep;
	short		hOverlap;
	short		vOverlap;
	
								/** Instance Methods **/
									/** Construct/Desctruction **/
	void		IScrollPane(
		CView			*anEnclosure,
		CBureaucrat		*aSupervisor,
		short			aWidth,
		short			aHeight,
		short			aHEncl,
		short			aVEncl,
		SizingOption	aHSizing,
		SizingOption	aVSizing,
		Boolean			hasHoriz,
		Boolean			hasVert,
		Boolean			hasSizeBox);
	virtual void		IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);
	void		IScrollPaneX(Boolean hasHoriz, Boolean hasVert,
								Boolean hasSizeBox);
	
									/** Accessing **/
	virtual void		InstallPanorama(CPanorama *aPanorama);
	virtual void		SetSteps(short aHStep, short aVStep);
	virtual void		GetSteps(short *theHStep, short *theVStep);
	virtual void		SetOverlaps(short aHOverlap, short aVOverlap);
	virtual void		GetInterior( LongRect *theInterior);

									/** Scroll Bar Maintenance **/
	virtual void		AdjustScrollMax(void);
	virtual void		Calibrate(void);
	virtual void		ChangeSize(Rect *delta, Boolean redraw);
	
									/** Scroll Performance **/
	virtual void		DoHorizScroll(short whichPart);
	virtual void		DoVertScroll(short whichPart);
	virtual void		DoThumbDrag(short hDelta, short vDelta);
	
	virtual void		DoScroll( long hDelta, long vDelta);
};

enum	// synonyms for some Boolean parameters
{
	kNoHScroll = FALSE,
	kHasHScroll,
	kNoVScroll = FALSE,
	kHasVScroll,
	kNoSizebox = FALSE,
	kHasSizebox
	
};


typedef struct	{						/* ScrollPane template					*/
	PaneTemp	sPaneTemp;
	short		hStep;
	short		vStep;
	short		hOverlap;
	short		vOverlap;
	short		hasHoriz;
	short		hasVert;
	short		hasSizeBox;
} ScrollPaneTemp, *ScrollPaneTempP;


	/* Scroll Action Functions called through pointers */
	
pascal void	SBarActionProc(ControlHandle macControl, short whichPart);
void		SBarThumbFunc(CScrollBar *theSBar, short delta);