/****
 * CSymWndGrid.h
 *
 *	Sym window grid class for the SignWriter key editor.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/

#pragma	once					/* Include only once */



#include "CGridSelector.h"
#include "KeyEditConsts.h"




struct CSymWndGrid : CGridSelector {

	
				/* Initialization */
	void		ISymWndGrid (CView *anEnclosure, CBureaucrat *aSupervisor,
							  short aWidth, short aHeight,
							  short aHEncl, short aVEncl,
							  SizingOption aHSizing, SizingOption aVSizing);
				
				
				/* Drawing */
	void		DrawGrid (void);
	void		DrawItem (short theItem, Rect *theBox);

	
				/* Mouse */
	void		DoClick (Point hitPt, short modifierKeys, long when);
	
			
				/* Grid mapping */
 	Boolean 	ValidItem (short theItem);
	short 		ItemToSymCode (short item);
    short 		SymCodeToItem (short symCode);

};
